Foxit PDF SDK

Public Types | Public Member Functions | List of all members
foxit::pdf::annots::Line Class Reference
Inheritance diagram for foxit::pdf::annots::Line:

## Public Types
enum | CapPos { e_CapPosInline = 0, e_CapPosTop = 1 }
| Enumeration for the position type of caption. More...
Public Types inherited from foxit::pdf::annots::Markup
enum | EndingStyle { e_EndingStyleNone = 0, e_EndingStyleSquare = 1, e_EndingStyleCircle = 2, e_EndingStyleDiamond = 3, e_EndingStyleOpenArrow = 4, e_EndingStyleClosedArrow = 5, e_EndingStyleButt = 6, e_EndingStyleROpenArrow = 7, e_EndingStyleRClosedArrow = 8, e_EndingStyleSlash = 9 }
| Enumeration for line ending style. More...
enum | MeasureType { e_MeasureTypeX = 0, e_MeasureTypeY = 1, e_MeasureTypeD = 2, e_MeasureTypeA = 3, e_MeasureTypeT = 4, e_MeasureTypeS = 5 }
| Enumeration for annotation's measure type. More...
enum | State { e_StateNone = 0, e_StateMarked = 1, e_StateUnmarked = 2, e_StateAccepted = 3, e_StateRejected = 4, e_StateCancelled = 5, e_StateCompleted = 6, e_StateDeferred = 7, e_StateFuture = 8 }
| Enumeration for markup annotation's state. More...
enum | StateModel { e_StateModelMarked = 1, e_StateModelReview = 2 }
| Enumeration for markup annotation's state model. More...
Public Types inherited from foxit::pdf::annots::Annot
enum | AppearanceType { e_AppearanceTypeNormal = 0, e_AppearanceTypeRollover = 1, e_AppearanceTypeDown = 2 }
| Enumeration for the type of annotation's appearance. More...
enum | Flags { e_FlagInvisible = 0x0001, e_FlagHidden = 0x0002, e_FlagPrint = 0x0004, e_FlagNoZoom = 0x0008, e_FlagNoRotate = 0x0010, e_FlagNoView = 0x0020, e_FlagReadOnly = 0x0040, e_FlagLocked = 0x0080, e_FlagToggleNoView = 0x0100, e_FlagLockedContents = 0x0200 }
| Enumeration for PDF annotation flags. More...
enum | HighlightingMode { e_HighlightingNone = 0, e_HighlightingInvert = 1, e_HighlightingOutline = 2, e_HighlightingPush = 3, e_HighlightingToggle = 4 }
| Enumeration for PDF annotation highlighting mode. More...
enum | MKEntry { e_MKEntryRotation = 0, e_MKEntryBorderColor = 1, e_MKEntryBackgroundColor = 2, e_MKEntryNormalCaption = 3, e_MKEntryRolloverCaption = 4, e_MKEntryDownCaption = 5, e_MKEntryNormalIcon = 6, e_MKEntryRolloverIcon = 7, e_MKEntryDownIcon = 8, e_MKEntryIconFit = 9, e_MKEntryIconCaptionRelation = 10 }
| Enumeration for annotation's MK dictionary (an appearance characteristics) entry. More...
enum | MKIconCaptionRelation { e_MKRelationNoIcon = 0, e_MKRelationNoCaption = 1, e_MKRelationCaptionBelowIcon = 2, e_MKRelationCaptionAboveIcon = 3, e_MKRelationCaptionRight = 4, e_MKRelationCaptionLeft = 5, e_MKRelationCaptionOvrlayOnIcon = 6 }
| Enumeration for icon and caption relative position in annotation's MK dictionary. More...
enum | Property { e_PropertyModifiedDate = 0, e_PropertyCreationDate = 1, e_PropertyBorderColor = 2, e_PropertyFillColor = 3 }
| Enumeration for some PDF annotation property. More...
enum | Type { e_UnknownType = 0, e_Note = 1, e_Link = 2, e_FreeText = 3, e_Line = 4, e_Square = 5, e_Circle = 6, e_Polygon = 7, e_PolyLine = 8, e_Highlight = 9, e_Underline = 10, e_Squiggly = 11, e_StrikeOut = 12, e_Stamp = 13, e_Caret = 14, e_Ink = 15, e_PSInk = 16, e_FileAttachment = 17, e_Sound = 18, e_Movie = 19, e_Widget = 20, e_Screen = 21, e_PrinterMark = 22, e_TrapNet = 23, e_Watermark = 24, e_3D = 25, e_Popup = 26, e_Redact = 27, e_RichMedia = 28, e_PagingSeal = 29 }
| Enumeration for PDF annotation type. More...

## Public Member Functions
| Line ()
| Constructor.
| Line (const Annot &annot)
| Constructor, with parent class object. More...
| ~Line ()
| Destructor.
void | EnableCaption (bool cap)
| Set the flag which is used to decide whether the content of current line annotation should be replicated as a caption in the appearance or not. More...
Offset | GetCaptionOffset () const
| Get caption offset values. More...
CapPos | GetCaptionPositionType () const
| Get the position type of caption. More...
PointF | GetEndPoint () const
| Get the end point. More...
float | GetLeaderLineExtensionLength () const
| Get the length of leader line extension. More...
float | GetLeaderLineLength () const
| Get the length of leader line. More...
float | GetLeaderLineOffset () const
| Get the length of leader line offset. More...
EndingStyle | GetLineEndStyle () const
| Get line ending style of the end point. More...
EndingStyle | GetLineStartStyle () const
| Get line ending style of the start point. More...
float | GetMeasureConversionFactor (MeasureType measure_type)
| Get the conversion factor for measuring. More...
String | GetMeasureRatio ()
| Get the scale ratio string for measuring. More...
WString | GetMeasureRatioW ()
| Get the scale ratio Unicode string for measuring. More...
String | GetMeasureUnit (MeasureType measure_type)
| Get the label for displaying the units for measuring. More...
WString | GetMeasureUnitW (MeasureType measure_type)
| Get the label (in Unicode string) for displaying the units for measuring. More...
PointF | GetStartPoint () const
| Get the start point. More...
RGB | GetStyleFillColor () const
| Get fill color for ending styles. More...
bool | HasCaption () const
| Check whether the content of current line annotation should be replicated as a caption in the appearance or not. More...
void | SetCaptionOffset (const Offset &offset)
| Set caption offset values. More...
void | SetCaptionPositionType (CapPos cap_position)
| Set the position type of caption. More...
void | SetEndPoint (const PointF &point)
| Set the end point. More...
void | SetLeaderLineExtensionLength (float extension_length)
| Set the length of leader line extension. More...
void | SetLeaderLineLength (float length)
| Set the length of leader line. More...
void | SetLeaderLineOffset (float offset)
| Set the length of leader line offset. More...
void | SetLineEndStyle (EndingStyle ending_style)
| Set line ending style of the end point. More...
void | SetLineStartStyle (EndingStyle ending_style)
| Set line ending style of the start point. More...
void | SetMeasureConversionFactor (MeasureType measure_type, float factor)
| Set the conversion factor for measuring. More...
void | SetMeasureRatio (const String &ratio)
| Set the scale ratio string for measuring. More...
void | SetMeasureUnit (MeasureType measure_type, const String &unit)
| Set the label for displaying the units for measuring. More...
void | SetStartPoint (const PointF &point)
| Set the start point. More...
void | SetStyleFillColor (RGB color)
| Set fill color for ending styles. More...
Public Member Functions inherited from foxit::pdf::annots::Markup
| Markup ()
| Constructor.
| Markup (const Annot &annot)
| Constructor, with parent class object. More...
| ~Markup ()
| Destructor.
Note | AddReply ()
| Add a new reply to the end of reply list. More...
void | AddRichText (const WString &content, const RichTextStyle &style)
| Add a new rich text string to the end. More...
Note | AddStateAnnot (const WString &title, StateModel model, State state)
| Add a new state annotation. More...
float | GetBorderOpacity () const
| Get the border opacity of the annotation. More...
DateTime | GetCreationDateTime () const
| Get creation date time. More...
float | GetFillOpacity () const
| Get the fill opacity of the annotation. More...
MarkupArray | GetGroupElements ()
| Get an element (as markup annotation) from the group that current markup annotation belongs to. More...
Markup | GetGroupHeader ()
| Get the header annotation (as primary annotation) of the group that current markup annotation belongs to. More...
String | GetIntent () const
| Get intent name. More...
float | GetOpacity () const
| Get opacity value. More...
Popup | GetPopup ()
| Get related pop-up annotation. More...
Note | GetReply (int index) const
| Get a reply by index. More...
int | GetReplyCount ()
| Count all replies. More...
WString | GetRichTextContent (int32 index)
| Get text string of a rich text string specified by index. More...
int32 | GetRichTextCount ()
| Get the count of rich text strings. More...
RichTextStyle | GetRichTextStyle (int32 index)
| Get style data of a rich text string specified by index. More...
NoteArray | GetStateAnnots (StateModel model)
| Get all state annotations in a specified state model. More...
WString | GetSubject () const
| Get subject string. More...
WString | GetTitle () const
| Get title string. More...
void | InsertRichText (int32 index, const WString &content, const RichTextStyle &style)
| Insert a new rich text string to the place which is specified by index. More...
bool | IsGrouped ()
| Check whether current markup annotation is in a group or not. More...
bool | RemoveAllReplies ()
| Remove all the replies. More...
bool | RemoveAllStateAnnots ()
| Remove all the state annotations. More...
bool | RemovePopup ()
| Remove related pop-up annotation. More...
bool | RemoveReply (int index)
| Remove a reply by index. More...
void | RemoveRichText (int index)
| Remove a rich text string specified by index. More...
void | SetBorderOpacity (float opacity)
| Set the border opacity of the annotation. More...
void | SetCreationDateTime (const DateTime &date_time)
| Set creation date time. More...
void | SetFillOpacity (float opacity)
| Set the fill opacity of the annotation. More...
void | SetIntent (const String &intent)
| Set intent name. More...
void | SetOpacity (float opacity)
| Set opacity value. More...
void | SetPopup (const Popup &popup)
| Set related pop-up annotation. More...
void | SetRichTextContent (int32 index, const WString &content)
| Set text string of a rich text string specified by index. More...
void | SetRichTextStyle (int32 index, const RichTextStyle &style)
| Set style data of a rich text string specified by index. More...
void | SetSubject (const WString &subject)
| Set subject string. More...
void | SetTitle (const WString &title)
| Set title string. More...
bool | Ungroup ()
| Ungroup current markup annotation from the group it belongs to. More...
Public Member Functions inherited from foxit::pdf::annots::Annot
| Annot ()
| Constructor.
| Annot (const Annot &annot)
| Constructor, with another annotation object. More...
| Annot (const PDFPage &page, objects::PDFDictionary *annot_dict)
| Constructor, with PDF page and annotation's PDF dictionary. More...
virtual | ~Annot ()
| Destructor.
objects::PDFStream * | GetAppearanceStream (AppearanceType type, const char *appearance_state="") const
| Get annotation's appearance stream with specified type and state. More...
RGB | GetBorderColor () const
| Get border color. More...
BorderInfo | GetBorderInfo () const
| Get border information. More...
WString | GetContent () const
| Get content. More...
RectI | GetDeviceRect (const Matrix &matrix)
| Get annotation rectangle in device coordinate system. More...
objects::PDFDictionary * | GetDict () const
| Get annotation's dictionary object. More...
Matrix | GetDisplayMatrix (const Matrix &page_display_matrix)
| Get the display matrix, from PDF coordinate system to targeted device coordinate system. More...
uint32 | GetFlags () const
| Get annotation flags. More...
int | GetIndex () const
| Get the index of current annotation in the page which current annotation belongs to. More...
DateTime | GetModifiedDateTime () const
| Get last modified date time. More...
objects::PDFDictionary * | GetOptionalContent () const
| Get the PDF dictionary of annotation's optional content. More...
PDFPage | GetPage () const
| Get the related PDF page. More...
RectF | GetRect () const
| Get rectangle, in PDF coordinate system. More...
Type | GetType () const
| Get actual annotation type of current annotation. More...
WString | GetUniqueID () const
| Get unique ID. More...
bool | HasProperty (Property property) const
| Whether current annotation has the specified annotation's property. More...
bool | IsEmpty () const
| Check whether current object is empty or not. More...
bool | IsMarkup () const
| Check if current annotation is a markup annotation. More...
bool | Move (const RectF &rect)
| Move current annotation to a new position, specified by a new rectangle in PDF coordinate system. More...
bool | Move (const RectF &rect, bool is_reset_appearance)
| Move current annotation to a new position, specified by a new rectangle in PDF coordinate system. More...
bool | operator!= (const Annot &other) const
| Not equal operator. More...
Annot & | operator= (const Annot &annot)
| Assign operator. More...
bool | operator== (const Annot &other) const
| Equal operator. More...
bool | RemoveProperty (Property property)
| Remove a specified annotation's property. More...
bool | ResetAppearanceStream ()
| Reset appearance stream. More...
bool | ResetAppearanceStream (bool is_generate_new_appearance_obj)
| Reset appearance stream. More...
void | SetBorderColor (RGB color)
| Set border color. More...
void | SetBorderInfo (const BorderInfo &border)
| Set border information. More...
void | SetContent (const WString &content)
| Set content. More...
void | SetFlags (uint32 flags)
| Set annotation flags. More...
void | SetModifiedDateTime (const DateTime &date_time)
| Set last modified date time. More...
void | SetUniqueID (const WString &unique_id)
| Set unique ID. More...
Public Member Functions inherited from foxit::Base
FS_HANDLE | Handle () const
| Get the handle of current object. More...

## Detailed Description

A line annotation displays a single straight line on the page.
Line annotation is a kind of markup annotation, so class Line is derived from class Markup, and also offers functions to get/set line annotation's properties and reset appearance stream of a line annotation.
For a line annotation, start point and end point are required. So please ensure that a line annotation has valid start point and end point before resetting its appearance stream; otherwise the line annotation cannot be reset appearance stream.

Note
  For a newly created line annotation, if user calls function Annot::ResetAppearanceStream directly after setting required start point and end point property and not setting any other properties, the default appearance will be used:
  border width = 2.0, border style = BorderInfo::e_Solid, border color = 0xFFFF0000 (red), opacity = 1, line starting/ending styles = "None", no caption is enabled.

See also
  Markup

## Member Enumeration Documentation

## ◆ CapPos

enum foxit::pdf::annots::Line::CapPos

Enumeration for the position type of caption.

Values of this enumeration should be used alone.

Enumerator
e_CapPosInline | The caption shall be centered inside the line
e_CapPosTop | The caption shall be on top of the line

## Constructor & Destructor Documentation

## ◆ Line()

foxit::pdf::annots::Line::Line | ( | const Annot & | annot | ) |
| explicit

Constructor, with parent class object.

Parameters

  [in] | annot | Parent class object.

## Member Function Documentation

## ◆ EnableCaption()

void foxit::pdf::annots::Line::EnableCaption | ( | bool | cap | ) |

Set the flag which is used to decide whether the content of current line annotation should be replicated as a caption in the appearance or not.

This property has effect on line annotation's appearance. If user wants the effect to be shown in annotation's appearance, please call function Annot::ResetAppearanceStream after this function.

Parameters

  [in] | cap | true means the content should be replicated as a caption in the appearance of current line annotation, while false means not.

Returns
  None.

## ◆ GetCaptionOffset()

Offset foxit::pdf::annots::Line::GetCaptionOffset | ( |  | ) | const

Get caption offset values.

Caption offset is the offset of caption from its normal position.
Only when current line annotation have a caption, this property is meaningful and has effect on line's annotation's appearance. Function Line::HasCaption can be used to check if current line annotation should have a caption, and function Line::EnableCaption can be used to change the status.

Returns
  A Offset object that receives horizontal offset and vertical offset for caption.
  A Offset object with value (0, 0) may also mean that no caption offset values can be found.

## ◆ GetCaptionPositionType()

CapPos foxit::pdf::annots::Line::GetCaptionPositionType | ( |  | ) | const

Get the position type of caption.

Only when current line annotation have a caption, this property is meaningful and has effect on line's annotation's appearance. Function Line::HasCaption can be used to check if current line annotation should have a caption, and function Line::EnableCaption can be used to change the status.

Returns
  The position type of caption. Please refer to values starting from Line::e_CapPosInline and this would be one of these values.

## ◆ GetEndPoint()

PointF foxit::pdf::annots::Line::GetEndPoint | ( |  | ) | const

Get the end point.

Start point and end point are required for a line annotation. They have effect on line annotation's appearance.

Returns
  The end point. A point with value (0, 0) may also mean that no start point is found.

## ◆ GetLeaderLineExtensionLength()

float foxit::pdf::annots::Line::GetLeaderLineExtensionLength | ( |  | ) | const

Get the length of leader line extension.

Leader line extensions extend from the line proper 180 degrees from the leader lines.
For more details, please refer to "Line Annotations" in Section 8.4.5 "Annotation Types" of <PDF reference 1.7> .

Returns
  The length of leader line extension.

## ◆ GetLeaderLineLength()

float foxit::pdf::annots::Line::GetLeaderLineLength | ( |  | ) | const

Get the length of leader line.

Leader lines extend from each endpoint of a line perpendicular to the line itself. A positive value means that the leader lines appear in the direction that is clockwise when traversing the line from its start point to its end point; a negative value indicates the opposite direction. Specially, even the length of leader line is 0, the line annotation can still have leader line extension and leader line offset. For this case, the direction of leader line is same as positive length value in order that the direction or position of leader line extension and offset can still be judged.
For more details, please refer to "Line Annotations" in Section 8.4.5 "Annotation Types" of <PDF reference 1.7> .

Returns
  The length of leader line.

## ◆ GetLeaderLineOffset()

float foxit::pdf::annots::Line::GetLeaderLineOffset | ( |  | ) | const

Get the length of leader line offset.

Leader line offset is the amount of empty space between the endpoints of the line annotation and the beginning of the leader lines.
For more details, please refer to "Line Annotations" in Section 8.4.5 "Annotation Types" of <PDF reference 1.7> .

Returns
  The length of leader line offset.

## ◆ GetLineEndStyle()

EndingStyle foxit::pdf::annots::Line::GetLineEndStyle | ( |  | ) | const

Get line ending style of the end point.

This property has effect on line annotation's appearance.

Returns
  The line ending style of the end point. Please refer to values starting from Markup::e_EndingStyleNone and this would be one of these values.

## ◆ GetLineStartStyle()

EndingStyle foxit::pdf::annots::Line::GetLineStartStyle | ( |  | ) | const

Get line ending style of the start point.

This property has effect on line annotation's appearance.

Returns
  The line ending style of the start point. Please refer to values starting from Markup::e_EndingStyleNone and this would be one of these values.

## ◆ GetMeasureConversionFactor()

float foxit::pdf::annots::Line::GetMeasureConversionFactor | ( | MeasureType | measure_type | ) |

Get the conversion factor for measuring.

A line annotation may have a measure dictionary that specifies an alternate coordinate system for a region of a page. Please refer to P745 in <PDF Reference 1.7> for more details.

Parameters

  [in] | measure_type | Measure type. Please refer to values starting from Markup::e_MeasureTypeX and this would be one of these values.

Returns
  The conversion factor.

## ◆ GetMeasureRatio()

String foxit::pdf::annots::Line::GetMeasureRatio | ( |  | ) |

Get the scale ratio string for measuring.

A line annotation may have a measure dictionary that specifies an alternate coordinate system for a region of a page. Scale ratio string expresses the scale ratio of the drawing in the region. Please refer to P745 in <PDF Reference 1.7> for more details.

Returns
  A UTF-8 byte string that expresses the scale ratio.

## ◆ GetMeasureRatioW()

WString foxit::pdf::annots::Line::GetMeasureRatioW | ( |  | ) |

Get the scale ratio Unicode string for measuring.

A line annotation may have a measure dictionary that specifies an alternate coordinate system for a region of a page. Scale ratio string expresses the scale ratio of the drawing in the region. Please refer to P745 in <PDF Reference 1.7> for more details.

Returns
  A Unicode string that expresses the scale ratio.

## ◆ GetMeasureUnit()

String foxit::pdf::annots::Line::GetMeasureUnit | ( | MeasureType | measure_type | ) |

Get the label for displaying the units for measuring.

A line annotation may have a measure dictionary that specifies an alternate coordinate system for a region of a page. Please refer to P745 in <PDF Reference 1.7> for more details.

Parameters

  [in] | measure_type | Measure type. Please refer to values starting from Markup::e_MeasureTypeX and this should be one of these values.

Returns
  A UTF-8 text string that represents a label for displaying the units.

## ◆ GetMeasureUnitW()

WString foxit::pdf::annots::Line::GetMeasureUnitW | ( | MeasureType | measure_type | ) |

Get the label (in Unicode string) for displaying the units for measuring.

A line annotation may have a measure dictionary that specifies an alternate coordinate system for a region of a page. Please refer to P745 in <PDF Reference 1.7> for more details.

Parameters

  [in] | measure_type | Measure type. Please refer to values starting from Markup::e_MeasureTypeX and this should be one of these values.

Returns
  A Unicode string that represents a label for displaying the units.

## ◆ GetStartPoint()

PointF foxit::pdf::annots::Line::GetStartPoint | ( |  | ) | const

Get the start point.

Start point and end point are required for a line annotation. They have effect on line annotation's appearance.

Returns
  The start point. A point with value (0, 0) may also mean that no start point is found.

## ◆ GetStyleFillColor()

RGB foxit::pdf::annots::Line::GetStyleFillColor | ( |  | ) | const

Get fill color for ending styles.

This property has effect on line annotation's appearance. Fill color is used for some line ending styles:
"Square", "Circle", "Diamond", "ClosedArrow", "RClosedArrow".

Returns
  The fill color of ending styles. Format: 0xRRGGBB. If no fill color can be found, 0x000000 will be returned.

## ◆ HasCaption()

bool foxit::pdf::annots::Line::HasCaption | ( |  | ) | const

Check whether the content of current line annotation should be replicated as a caption in the appearance or not.

Returns
  true means the content should be replicated as a caption in the appearance of current line annotation. false means not to replicate the content as a caption in the appearance of current line annotation.

## ◆ SetCaptionOffset()

void foxit::pdf::annots::Line::SetCaptionOffset | ( | const Offset & | offset | ) |

Set caption offset values.

Caption offset is the offset of caption from its normal position.
Only when current line annotation have a caption, this property is meaningful and has effect on line's annotation's appearance. Function Line::HasCaption can be used to check if current line annotation should have a caption, and function Line::EnableCaption can be used to change the status.
If user wants the effect to be shown in annotation's appearance, please call function Annot::ResetAppearanceStream after this function.

Parameters

  [in] | offset | New offset values .

Returns
  None.

## ◆ SetCaptionPositionType()

void foxit::pdf::annots::Line::SetCaptionPositionType | ( | CapPos | cap_position | ) |

Set the position type of caption.

Only when current line annotation have a caption, this property is meaningful and has effect on line's annotation's appearance. Function Line::HasCaption can be used to check if current line annotation should have a caption, and function Line::EnableCaption can be used to change the status.
If user wants the effect to be shown in annotation's appearance, please call function Annot::ResetAppearanceStream after this function.

Parameters

  [in] | cap_position | The position type of caption. Please refer to values starting from Line::e_CapPosInline and this should be one of these values.

Returns
  None.

## ◆ SetEndPoint()

void foxit::pdf::annots::Line::SetEndPoint | ( | const PointF & | point | ) |

Set the end point.

Start point and end point are required for a line annotation. They have effect on line annotation's appearance.
If user wants the new end point has effect on annotation's appearance, please call function Annot::ResetAppearanceStream after setting new end point.

Parameters

  [in] | point | New point that specifies the end point.

Returns
  None.

## ◆ SetLeaderLineExtensionLength()

void foxit::pdf::annots::Line::SetLeaderLineExtensionLength | ( | float | extension_length | ) |

Set the length of leader line extension.

Leader line extensions extend from the line proper 180 degrees from the leader lines.
For more details, please refer to "Line Annotations" in Section 8.4.5 "Annotation Types" of <PDF reference 1.7> .

Parameters

  [in] | extension_length | The length of leader line extension. It should be a non-negative value. 0 means no leader line extension.

Returns
  None.

## ◆ SetLeaderLineLength()

void foxit::pdf::annots::Line::SetLeaderLineLength | ( | float | length | ) |

Set the length of leader line.

Leader lines extend from each endpoint of a line perpendicular to the line itself. A positive value means that the leader lines appear in the direction that is clockwise when traversing the line from its start point to its end point; a negative value indicates the opposite direction. Specially, even the length of leader line is 0, the line annotation can still have leader line extension and leader line offset. For this case, the direction of leader line is same as positive length value in order that the direction or position of leader line extension and offset can still be judged.
For more details, please refer to "Line Annotations" in Section 8.4.5 "Annotation Types" of <PDF reference 1.7> .

Parameters

  [in] | length | The length of leader lines. See details part for more details. 0 means no leader line.

Returns
  None.

## ◆ SetLeaderLineOffset()

void foxit::pdf::annots::Line::SetLeaderLineOffset | ( | float | offset | ) |

Set the length of leader line offset.

Leader line offset is the amount of empty space between the endpoints of the line annotation and the beginning of the leader lines.
For more details, please refer to "Line Annotations" in Section 8.4.5 "Annotation Types" of <PDF reference 1.7> .

Parameters

  [in] | offset | The length of leader line offset. It should be a non-negative value. 0 means no leader line extension.

Returns
  None.

## ◆ SetLineEndStyle()

void foxit::pdf::annots::Line::SetLineEndStyle | ( | EndingStyle | ending_style | ) |

Set line ending style of the end point.

This property has effect on line annotation's appearance. If user wants the new line ending style has effect on annotation's appearance, please call function Annot::ResetAppearanceStream after setting new line ending style.

Parameters

  [in] | ending_style | The line ending style for the end point to be set. Please refer to values starting from Markup::e_EndingStyleNone and this should be one of these values.

Returns
  None.

## ◆ SetLineStartStyle()

void foxit::pdf::annots::Line::SetLineStartStyle | ( | EndingStyle | ending_style | ) |

Set line ending style of the start point.

This property has effect on line annotation's appearance. If user wants the new line ending style has effect on annotation's appearance, please call function Annot::ResetAppearanceStream after setting new line ending style.

Parameters

  [in] | ending_style | The line ending style for the start point to be set. Please refer to values starting from Markup::e_EndingStyleNone and this should be one of these values.

Returns
  None.

## ◆ SetMeasureConversionFactor()

void foxit::pdf::annots::Line::SetMeasureConversionFactor | ( | MeasureType | measure_type,
|  | float | factor
| ) |  |

Set the conversion factor for measuring.

A line annotation may have a measure dictionary that specifies an alternate coordinate system for a region of a page. Please refer to P745 in <PDF Reference 1.7> for more details.

Parameters

  [in] | measure_type | Measure type. Please refer to values starting from Markup::e_MeasureTypeX and this would be one of these values.
  [in] | factor | The conversion factor.

Returns
  None.

## ◆ SetMeasureRatio()

void foxit::pdf::annots::Line::SetMeasureRatio | ( | const String & | ratio | ) |

Set the scale ratio string for measuring.

A line annotation may have a measure dictionary that specifies an alternate coordinate system for a region of a page. Scale ratio string expresses the scale ratio of the drawing in the region. Please refer to P745 in <PDF Reference 1.7> for more details.

Parameters

  [in] | ratio | A UTF-8 byte string expressing the scale ratio. The string should be like: "1/4 in = 1 ft", indicating that 1/4 inches in default user space is equivalent to 1 foot in real-world measurements.

Returns
  None.

## ◆ SetMeasureUnit()

void foxit::pdf::annots::Line::SetMeasureUnit | ( | MeasureType | measure_type,
|  | const String & | unit
| ) |  |

Set the label for displaying the units for measuring.

A line annotation may have a measure dictionary that specifies an alternate coordinate system for a region of a page. Please refer to P745 in <PDF Reference 1.7> for more details.

Parameters

  [in] | measure_type | Measure type. Please refer to values starting from Markup::e_MeasureTypeX and this should be one of these values.
  [in] | unit | A UTF-8 text string that specifies a label for displaying the units.

Returns
  None.

## ◆ SetStartPoint()

void foxit::pdf::annots::Line::SetStartPoint | ( | const PointF & | point | ) |

Set the start point.

Start point and end point are required for a line annotation. They have effect on line annotation's appearance.
If user wants the new start point has effect on annotation's appearance, please call function Annot::ResetAppearanceStream after setting new start point.

Parameters

  [in] | point | New point that specifies the start point.

Returns
  None.

## ◆ SetStyleFillColor()

void foxit::pdf::annots::Line::SetStyleFillColor | ( | RGB | color | ) |

Set fill color for ending styles.

This property has effect on line annotation's appearance. Fill color is used for some line ending styles:
"Square", "Circle", "Diamond", "ClosedArrow", "RClosedArrow".
If user wants the new fill color has effect on annotation's appearance, please call function Annot::ResetAppearanceStream after setting new fill color.

Parameters

  [in] | color | New fill color of ending style. Format: 0xRRGGBB.

Returns
  None.